$! make xmajongg under VMS
$!
$! In case of problems with the install you might contact me at 
$! zinser@decus.de (preferred) or zinser@sysdev.exchange.de
$!
$! Just some general constants
$!
$  true  = 1
$  false = 0 
$!
$! Check for command parameters
$!
$  if (f$edit(p1,"UPCASE").eqs."INSTALL") then goto install
$  p2 = f$edit(p2,"UPCASE")
$  if (p2.eqs."")
$  then 
$    fil_loc = "XMAHJONG_DIR:"
$  else 
$    if (p2.eqs."HERE")
$    then
$      fil_loc = f$environment("DEFAULT")
$    else
$      fil_loc = p2
$    endif 
$  endif
$  ccopt = "/define=(GLOBAL=""""extern"""",LAYOUT=""""""""""""''fil_loc'"""""""""""")"
$!
$! Look for the compiler used
$!
$ if f$getsyi("HW_MODEL").ge.1024
$ then
$  ccopt = "/prefix=all/ext=common"+ccopt
$  if f$trnlnm("SYS").eqs."" then define sys sys$library:
$  decc = true
$ else
$  if f$search("SYS$SYSTEM:DECC$COMPILER.EXE").eqs.""
$   then
$    if f$trnlnm("SYS").eqs."" then define sys sys$library:
$    if f$trnlnm("NETINET").eqs."" then define netinet sys$library:
$    ccopt = "/include=sys$disk:[]" + ccopt
$    decc = false  
$   else
$    if f$trnlnm("SYS").eqs."" then define sys decc$library_include:
$    ccopt = "/decc/prefix=all/ext=common"+ccopt
$    decc = true
$  endif
$ endif
$!
$!      Build the option-file
$!
$ open/write optf xmahjongg.opt
$ write optf "draw"
$ write optf "event"
$ write optf "initial"
$ write optf "packet"
$ write optf "play"
$ write optf "random"
$ write optf "sysdep"
$ write optf "variables"
$ write optf "xmahjongg"
$ if .not.decc 
$ then 
$   write optf "getopt"
$   write optf "vms_strings"
$   write optf "SYS$SHARE:UCX$IPC.OLB/LIB"
$ endif
$ write optf "Identification=""Xmahjongg 2.0"""
$!
$!  Find out which X-Version we're running.  This will fail for older
$!  VMS versions (i.e., v5.5-1).  Therefore, choose DECWindows XUI for
$!  default.
$!
$ On Error Then GoTo XUI
$ @sys$update:decw$get_image_version sys$share:decw$xlibshr.exe decw$version
$ if f$extract(4,3,decw$version).eqs."1.0"
$ then
$   write optf "Sys$share:DECW$DWTLIBSHR.EXE/Share"
$ endif
$ if f$extract(4,3,decw$version).eqs."1.1"
$ then
$   write optf "sys$share:decw$xtshr.exe/share"
$ endif
$ if f$extract(4,3,decw$version).eqs."1.2"
$ then
$   write optf "sys$share:decw$xtlibshrr5.exe/share"
$ endif
$ GoTo MAIN
$!
$ XUI:
$!
$   write optf "Sys$share:DECW$DWTLIBSHR.EXE/Share"
$ MAIN:
$ On Error Then exit
$ write optf "sys$share:decw$xlibshr.exe/share"
$ close optf
$!
$! Build the thing 
$!
$ write sys$output "Compiling Xmahjongg sources ..."
$ CALL MAKE draw.OBJ "CC ''CCOPT' draw" -
  	    draw.c 
$ CALL MAKE event.OBJ "CC ''CCOPT' event" -
  	    event.c 
$ CALL MAKE initial.OBJ "CC ''CCOPT' initial" -
  	    initial.c 
$ CALL MAKE packet.OBJ "CC ''CCOPT' packet" -
  	    packet.c 
$ CALL MAKE play.OBJ "CC ''CCOPT' play" -
  	    play.c 
$ CALL MAKE random.OBJ "CC ''CCOPT' random" -
  	    random.c 
$ CALL MAKE sysdep.OBJ "CC ''CCOPT' sysdep" -
  	    sysdep.c 
$ CALL MAKE variables.OBJ "CC ''CCOPT' variables" -
  	    variables.c 
$ CALL MAKE xmahjongg.OBJ "CC ''CCOPT' xmahjongg" -
  	    xmahjongg.c 
$ if .not.decc
$ then
$   CALL MAKE getopt.OBJ "CC ''CCOPT' getopt" -
    	      getopt.c
$   CALL MAKE vms_strings.OBJ "CC ''CCOPT' vms_strings" -
    	      vms_strings.c
$ endif 
$ write sys$output "Linking Xmahjongg..."
$ call make xmahjongg.exe "LINK xmahjongg.opt/opt" *.obj
$ write sys$output "Xmahjongg build completed"
$ exit
$!
$!
$MAKE: SUBROUTINE   !SUBROUTINE TO CHECK DEPENDENCIES
$ V = 'F$Verify(0)
$! P1 = What we are trying to make
$! P2 = Command to make it
$! P3 - P8  What it depends on
$
$ If F$Search(P1) .Eqs. "" Then Goto Makeit
$ Time = F$CvTime(F$File(P1,"RDT"))
$arg=3
$Loop:
$       Argument = P'arg
$       If Argument .Eqs. "" Then Goto Exit
$       El=0
$Loop2:
$       File = F$Element(El," ",Argument)
$       If File .Eqs. " " Then Goto Endl
$       AFile = ""
$Loop3:
$       OFile = AFile
$       AFile = F$Search(File)
$       If AFile .Eqs. "" .Or. AFile .Eqs. OFile Then Goto NextEl
$       If F$CvTime(F$File(AFile,"RDT")) .Ges. Time Then Goto Makeit
$       Goto Loop3
$NextEL:
$       El = El + 1
$       Goto Loop2
$EndL:
$ arg=arg+1
$ If arg .Le. 8 Then Goto Loop
$ Goto Exit
$
$Makeit:
$ VV=F$VERIFY(0)
$ write sys$output P2
$ 'P2
$ VV='F$Verify(VV)
$Exit:
$ If V Then Set Verify
$ENDSUBROUTINE
$INSTALL:
$ on error then goto fontinst_err
$ if f$getsyi("HW_MODEL").ge.1024
$ then
$   Copy XMAHJONGG.PCF SYS$COMMON:[SYSFONT.DECW.COMMON]* /lo/prot=(w:re)
$   MKFONTDIR :== FONTCOMPILER/DIRECTORY
$   MKFONTDIR SYS$COMMON:[SYSFONT.DECW.COMMON]
$ else
$   Copy XMAHJONGG.DECW$FONT SYS$COMMON:[SYSFONT.DECW.COMMON]* /lo/prot=(w:re)
$   MKFONTDIR :== $DECW$MKFONTDIR
$   MKFONTDIR SYS$COMMON:[SYSFONT.DECW.COMMON]
$ endif
$ write sys$output "Font installed ..."
$ write sys$output -
   "You might need to restart DECwindows with @SYS$MANAGER:DECW$STARTUP RESTART"
$ exit
$FONTINST_ERR:
$ write sys$output "Sorry, you're missing rights to install systemwide fonts"
$ write sys$output "Exiting now ..."
$ exit  
